
/**
 * Synchronous and asynchronous client classes for accessing AmazonAutoScaling.
 *
 * Auto Scaling <p>
 * Auto Scaling is a web service designed to automatically launch or
 * terminate Amazon Elastic Compute Cloud (Amazon EC2) instances based on
 * user-defined policies, schedules, and health checks. This service is
 * used in conjunction with Amazon CloudWatch and Elastic Load Balancing
 * services.
 * </p>
 * <p>
 * Auto Scaling provides APIs that you can call by submitting a Query
 * Request. Query requests are HTTP or HTTPS requests that use the HTTP
 * verbs GET or POST and a Query parameter named <i>Action</i> or
 * <i>Operation</i> that specifies the API you are calling. Action is
 * used throughout this documentation, although Operation is also
 * supported for backward compatibility with other Amazon Web Services
 * (AWS) Query APIs.
 * </p>
 * <p>
 * Calling the API using a Query request is the most direct way to access
 * the web service, but requires that your application handle low-level
 * details such as generating the hash to sign the request and error
 * handling. The benefit of calling the service using a Query request is
 * that you are assured of having access to the complete functionality of
 * the API. For information about signing a a query request, see
 * <a href="http://docs.aws.amazon.com/AutoScaling/latest/DeveloperGuide/api_requests.html"> Use Query Requests to Call Auto Scaling APIs </a>
 * 
 * </p>
 * <p>
 * This guide provides detailed information about Auto Scaling actions,
 * data types, parameters, and errors. For detailed information about
 * Auto Scaling features and their associated API actions, go to the
 * <a href="http://docs.aws.amazon.com/AutoScaling/latest/DeveloperGuide/"> Auto Scaling Developer Guide </a>
 * .
 * </p>
 * <p>
 * This reference is based on the current WSDL, which is available at:
 * </p>
 * <p>
 * 
 * <a href="http://autoscaling.amazonaws.com/doc/2011-01-01/AutoScaling.wsdl"> http://autoscaling.amazonaws.com/doc/2011-01-01/AutoScaling.wsdl </a>
 * 
 * </p>
 * <p>
 * <b>Endpoints</b>
 * </p>
 * <p>
 * The examples in this guide assume that your instances are launched in
 * the US East (Northern Virginia) region and use us-east-1 as the
 * endpoint.
 * </p>
 * <p>
 * You can set up your Auto Scaling infrastructure in other AWS regions.
 * For information about this product's regions and endpoints, see
 * <a href="http://docs.aws.amazon.com/general/latest/gr/index.html?rande.html"> Regions and Endpoints </a>
 * in the Amazon Web Services General Reference.
 * </p>
 */
 package com.amazonaws.services.autoscaling;
        